<?php
namespace bundle\windows;

use bundle\windows\WindowsScriptHost as WSH;
use php\io\File;
use php\lib\str;
use php\util\Regex;
use php\util\Scanner;

/**
 * @packages windows
 */
class Metadata 
{  
    /**
     * @var File
     */
    protected $file;

    /**
     * @var array
     */
    protected $data;

    /**
     * @var array
     */
    protected $keys = [
    //    0 => ['Имя'],
    //    1 => ['Размер'],
    //    2 => ['Тип элемента'],
    //    3 => ['Дата изменения'],
    //    4 => ['Дата создания'],
    //    5 => ['Дата доступа'],
    //    6 => ['Атрибуты'],
    //    7 => ['Автономность'],
    //    8 => ['Доступность'],
    //    9 => ['Распознанный тип'],
    //    10 => ['Владелец'],
    //    11 => ['Вид'],
        12 => ['Дата съемки'],
        13 => ['Исполнители'],
        14 => ['Альбом'],
        15 => ['Год'],
        16 => ['Жанр'],
        17 => ['Дирижер'],
        18 => ['Теги'],
    //    19 => ['Оценка'],
        20 => ['Авторы'],
        21 => ['Название'],
        22 => ['Тема'],
        23 => ['Категории'],
        24 => ['Комментарии'],
        25 => ['Авторские права'],
        26 => ['№'],
        27 => ['Продолжительность'],
        28 => ['Скорость потока', '(\d+)'],
        29 => ['С защитой'],
        30 => ['Камера, модель'],
        31 => ['Размеры', '(\d+)[x\s]+(\d+)', '$1x$2'],
        32 => ['Камера, изготовитель'],
        33 => ['Организация'],
        34 => ['Описание файла'],
        35 => ['Ключевые слова образцов'],
        36 => ['Ключевые слова образцов'],
        37 => ['Имя программы'],
        38 => ['Длительность'],
    //    39 => ['В сети'],
        40 => ['Повторяется'],
        41 => ['Место'],
        42 => ['Адреса необязательных участников'],
        43 => ['Необязательные участники'],
        44 => ['Адрес организатора'],
        45 => ['Имя организатора'],
        46 => ['Время оповещения'],
        47 => ['Адреса обязательных участников'],
        48 => ['Обязательные участники'],
        49 => ['Ресурсы'],
        50 => ['Состояние собрания'],
        51 => ['Свободно/Занято'],
    //    52 => ['Общий размер'],
        53 => ['Учетная запись'],
        55 => ['Состояние задачи'],
    //    56 => ['Компьютер'],
        57 => ['Годовщина'],
        58 => ['Имя помощника'],
        59 => ['Телефон помощника'],
        60 => ['День рождения'],
        61 => ['Работа, адрес'],
        62 => ['Работа, город'],
        63 => ['Работа, страна/регион'],
        64 => ['Работа, а/я'],
        65 => ['Работа, почтовый индекс'],
        66 => ['Работа, республика/край/область'],
        67 => ['Работа, улица'],
        68 => ['Работа, факс'],
        69 => ['Работа, домашняя страница'],
        70 => ['Работа, телефон'],
        71 => ['Номер обратного вызова'],
        72 => ['Телефон в машине'],
        73 => ['Дети'],
        74 => ['Организация, основной телефон'],
        75 => ['Отдел'],
        76 => ['Эл. почта'],
        77 => ['Эл. почта 2'],
        78 => ['Эл. почта 3'],
        79 => ['Эл. почта, список'],
        80 => ['Эл. почта, имя'],
        81 => ['Хранится как'],
        82 => ['Личное имя'],
        83 => ['Полное имя'],
        84 => ['Пол'],
        85 => ['Простое имя'],
        86 => ['Увлечения'],
        87 => ['Дом, адрес'],
        88 => ['Дом, город'],
        89 => ['Дом, страна/регион'],
        90 => ['Дом, а/я'],
        91 => ['Дом, почтовый индекс'],
        92 => ['Дом, республика/край/область'],
        93 => ['Дом, улица'],
        94 => ['Дом, факс'],
        95 => ['Дом, телефон'],
        96 => ['Мгн. сообщения'],
        97 => ['Инициалы'],
        98 => ['Должность'],
        99 => ['Метка'],
        100 => ['Фамилия'],
        101 => ['Почтовый адрес'],
        102 => ['Отчество, второе имя'],
        103 => ['Мобильный телефон'],
        104 => ['Псевдоним'],
        105 => ['Комната'],
        106 => ['Другой адрес'],
        107 => ['Другой адрес, город'],
        108 => ['Другой адрес, страна'],
        109 => ['Другой адрес, а/я'],
        110 => ['Другой адрес, индекс'],
        111 => ['Другой адрес, республика/область/край'],
        112 => ['Другой адрес, улица'],
        113 => ['Пейджер'],
        114 => ['Обращение'],
        115 => ['Город'],
        116 => ['Страна/Регион'],
        117 => ['а/я'],
        118 => ['Почтовый индекс'],
        119 => ['Республика/Область/Край'],
        120 => ['Улица'],
        121 => ['Основной адрес эл.почты'],
        122 => ['Основной телефон'],
        123 => ['Профессия'],
        124 => ['Супруг(а)/Партнер'],
        125 => ['Суффикс'],
        126 => ['Телетайп/телефон с титрами'],
        127 => ['Телекс'],
        128 => ['Веб-страница'],
        129 => ['Состояние содержимого'],
        130 => ['Тип содержимого'],
        131 => ['Дата приобретения'],
        132 => ['Дата архивирования'],
        133 => ['Дата завершения'],
        134 => ['Категория устройства'],
        135 => ['Подключено'],
        136 => ['Метод обнаружения'],
        137 => ['Понятное имя'],
        138 => ['Локальный компьютер'],
        139 => ['Производитель'],
        140 => ['Модель'],
        141 => ['Сопряжено'],
        142 => ['Классификация'],
        143 => ['Состояние'],
        144 => ['Статус'],
        145 => ['ИД клиента'],
        146 => ['Соавторы'],
        147 => ['Дата создания содержимого'],
        148 => ['Последний вывод на печать'],
        149 => ['Дата последнего сохранения'],
        150 => ['Подразделение'],
        151 => ['Код документа'],
        152 => ['Число страниц'],
        153 => ['Слайды'],
        154 => ['Общее время редактирования'],
        155 => ['Слова, количество'],
        156 => ['Срок'],
        157 => ['Дата окончания'],
        158 => ['Количество файлов'],
    //    159 => ['Расширение'],
    //    160 => ['Имя файла'],
    //    161 => ['Версия файла'],
        162 => ['Цвет флага'],
        163 => ['Состояние флажка'],
    //    164 => ['Свободно'],
        167 => ['Группа'],
        168 => ['Тип общего доступа'],
        169 => ['Глубина цвета'],
        170 => ['Горизонтальное разрешение', '(\d+)'],
        171 => ['Ширина', '(\d+)'],
        172 => ['Разрешение по вертикали', '(\d+)'],
        173 => ['Высота', '(\d+)'],
        174 => ['Важность'],
        175 => ['Вложение?'],
        176 => ['Удален'],
        177 => ['Состояние шифрования'],
        178 => ['С флагом'],
        179 => ['Завершено?'],
        180 => ['Неполное'],
    //    181 => ['Состояние чтения'],
    //    182 => ['Общий доступ'],
        183 => ['Создатели'],
        184 => ['Дата'],
    //    185 => ['Имя папки'],
    //    186 => ['Путь к папке'],
    //    187 => ['Расположение'],
    //    188 => ['Участники'],
    //    189 => ['Путь'],
    //    190 => ['По расположению'],
    //    191 => ['Тип'],
        192 => ['Имена контактов'],
        193 => ['Тип записи'],
        194 => ['Язык'],
        195 => ['Дата посещения'],
        196 => ['Описание'],
    //    197 => ['Состояние ссылки'],
        198 => ['Цель ссылки'],
        199 => ['URL-адрес'],
        203 => ['Дата создания мультимедиа'],
        204 => ['Дата выпуска'],
        205 => ['Зашифровано'],
        206 => ['Номер серии'],
        207 => ['Продюсер'],
        208 => ['Издатель'],
        209 => ['Номер сезона'],
        210 => ['Субтитры'],
        211 => ['URL-адрес веб-сайта пользователя'],
        212 => ['Сценарист'],
        214 => ['Вложения'],
        215 => ['СК (адреса)'],
        216 => ['СК'],
        217 => ['Копия (адреса)'],
        218 => ['Копия'],
        219 => ['Код разговора'],
        220 => ['Дата получения'],
        221 => ['Дата отправки'],
        222 => ['От кого (адреса)'],
        223 => ['От кого'],
        224 => ['С вложениями'],
        225 => ['Отправитель, адрес'],
        226 => ['Отправитель, имя'],
        227 => ['Магазин'],
        228 => ['Кому (адреса)'],
        229 => ['Название задачи'],
        230 => ['Имя получателя'],
        231 => ['Пробег'],
        232 => ['Исполнитель альбома'],
        233 => ['Сортировка по исполнителю'],
        234 => ['ИД альбома'],
        235 => ['Сортировка по альбому'],
        236 => ['Сортировка по участвующим исполнителям'],
        237 => ['Ударов в минуту'],
        238 => ['Композитор'],
        239 => ['Сортировка по композитору'],
        240 => ['Диск'],
        241 => ['Тональность'],
        242 => ['Часть компиляции'],
        243 => ['Настроение'],
        244 => ['Часть сборника'],
        245 => ['Период'],
        246 => ['Цветной'],
        247 => ['Родительский контроль'],
        248 => ['Причина выбора рейтинга'],
    //    249 => ['Использовано'],
        250 => ['Версия EXIF'],
        251 => ['Событие'],
        252 => ['Экспокоррекция', '(\d+)'],
        253 => ['Программа экспозиции'],
        254 => ['Выдержка', '(\d+\/\d+)'],
        255 => ['Диафрагма'],
        256 => ['Вспышка, режим'],
        257 => ['Фокусное расстояние', '(\d+)\D+', '$1mm'],
        258 => ['Фокусное расстояние, экв. 35 мм', '(\d+)\D+', '$1mm'],
        259 => ['Скорость ISO'],
        260 => ['Объектив, изготовитель'],
        261 => ['Объектив, модель'],
        262 => ['Источник света'],
        263 => ['Светосила'],
        264 => ['Экспозамер'],
        265 => ['Ориентация'],
        266 => ['Люди'],
        267 => ['Программный режим'],
        268 => ['Насыщенность'],
        269 => ['Расстояние до объекта'],
        270 => ['Баланс белого'],
        271 => ['Приоритет'],
        272 => ['Проект'],
        273 => ['Номер канала'],
        274 => ['Название серии'],
        275 => ['Скрытые титры'],
        276 => ['Повтор'],
        277 => ['SAP'],
        278 => ['Дата трансляции'],
        279 => ['Описание телепрограммы'],
        280 => ['Время записи'],
        281 => ['Позывные станции'],
        282 => ['Название станции'],
        283 => ['Сводка'],
        284 => ['Фрагменты'],
        285 => ['Автоматическая сводка'],
        286 => ['Релевантность'],
        287 => ['Владение файлами']
    ];

    /**
     * @param File|string $file
     */
    public function __construct($file){
        $this->file = ($file instanceof File) ? $file : File::of($file) ;
    }

    public function readData(){
        $ps = '
            $objShell = New-Object -ComObject Shell.Application
            $path = ":path"
            $file = ":file"
            $objFolder = $objShell.namespace($path)
            $objFile = $objFolder.parsename($file)
            0..287 | Foreach-Object { \'{0} = {1}\' -f $_, $objFolder.GetDetailsOf($objFile, $_) }
        ';

        $data = WSH::PowerShell($ps, ['file' => $this->file->getName(), 'path' => dirname($this->file->getAbsolutePath())]);
        return $this->parse($data);
    }

    protected function parse($data){
        $scanner = new Scanner($data, 'UTF-8');
        $this->data = [];
        
        while ($scanner->hasNextLine()) {
            $line = $scanner->nextLine();
            list($key, $value) = str::split($line, '=', 2);
            $key = intval(str::trim($key));
            $value = str::trim($value);
            if(isset($this->keys[$key]) and str::length($value) > 0){
                if(isset($this->keys[$key][1])){
                    $reg = Regex::of($this->keys[$key][1], Regex::UNICODE_CASE)->with($value);
                    if($reg->find()){
                        if(isset($this->keys[$key][2])){
                            $value = $reg->replace($this->keys[$key][2]);
                        } else {
                            $value = $reg->group(1);
                        }
                    }
                }

                $this->data[$key] = [
                    'description' => $this->keys[$key][0],
                    'value' => $value
                ];
            }
        }

        return $this->data;
    }
}